package com.ho.test.perf.measure.commons.jdbc;

import java.util.ArrayList;
import java.util.List;

import com.ho.test.perf.measure.commons.aop.PerformanceMonitor;
import com.ho.test.perf.measure.commons.tools.StopWatch;



/**
 * Allows to use JDBCTemplate from SpringFramework to execute sql query in JDBC
 * @a2.Version
 */
public class JdbcUtilsServiceImpl implements IJdbcUtils {
	// -------------------------------------------------------------- CONSTANTS
	// ----------------------------------------------------- PRIVATE ATTRIBUTES
	// ------------------------------------------------------------- EXCEPTIONS
	// ------------------------------------------------------- INTERNAL CLASSES
	// ----------------------------------------------------------- CONSTRUCTORS
	// --------------------------------------------------------- PUBLIC METHODS
	/**
	 * Execute query.
	 * @param sql the sql
	 * @return the query execution result as a List
	 */
	public List executeQuery(String sql) {
		StopWatch.getInstance().start(sql);
		try {
			Thread.currentThread().sleep(PerformanceMonitor.getRandomSleepTime());
		} catch(Throwable th){
		} finally {
			StopWatch.getInstance().stop(sql);
		}
		return new ArrayList();
	}

	// -------------------------------------------------------- PRIVATE METHODS
	// ------------------------------------------------------ PROTECTED METHODS
	// --------------------------------------------- ADVANCED GETTERS & SETTERS
	// ------------------------------------------------------ GETTERS & SETTERS
 }
